package Test;

import java.io.IOException;
import java.math.BigInteger;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.security.GeneralSecurityException;
import java.security.KeyStoreException;

import com.crypto.utils.AzTrustCryptoLib;
import com.crypto.utils.helpers.ConfigClass;
import com.crypto.utils.helpers.KeyStoreHolder;
import com.crypto.utils.helpers.KeyStoreLoader;

import java.util.ArrayList;
import java.util.Date;

public class AzTrustTest {

	static String readFile(String path, Charset encoding)
			  throws IOException
			{
			  byte[] encoded = Files.readAllBytes(Paths.get(path));
			  return new String(encoded, encoding);
			}
	
	public static void main(String[] args) {
		System.out.println("Begin test ..............................");
		
		AzTrustCryptoLib lib = new AzTrustCryptoLib();
		try{
			String file = "D:\\XadesDocs\\211115ZYACAZ20ARTS0001003404.xml";
			String content = readFile(file, StandardCharsets.UTF_8);
					
			String res = lib.VerifyXmlDocument(content, "Document");
			System.out.println("-----");
			System.out.println(res);
		}
		catch(Exception ex){
			System.err.println(ex.getMessage());
		}
		
		//TestLdap();	
		//TestLdap();	
		//TestLdap();	
		//TestLdap();	
		//TestLdap();
		
		//TestLoadWindowsKeyStore();
		
		//TestSignData();
		
		System.out.println("End test ..............................");
	}
	
	private static void TestLdap() {
		Date d1 = new Date(System.currentTimeMillis());
		
		String ldapServer = "ldap.bsxm.cbar.az";
		String ldapPort = "389";
		String ldapCertSearchDN = "CN=Certificate users,CN=PKI,DC=CBAR,DC=AZ";
		String ldp_usr = "";
		String ldp_pass = "";
		//String cer_issuer = "CN=ARMB BSXM, OU=Bank Sertifikat Xidmətləri Mərkəzi, O=Azərbaycan Respublikasının Mərkəzi Bankı, C=AZ";
		String cer_issuer = "CN = test_ca, C = AZ"; 
		//String cer_serial = "0215";
		String cer_serial = "408fc12d";
		AzTrustCryptoLib lib = new AzTrustCryptoLib();
		try{
			String res = lib.getCertificate(ldapServer, ldapPort, ldapCertSearchDN, ldp_usr, ldp_pass, cer_issuer, cer_serial);
			System.out.println(res);	
		}
		catch(Exception e){
			
		}
		
		Date d2 = new Date(System.currentTimeMillis());
		long diffInMillies = Math.abs(d2.getTime() - d1.getTime());
		System.out.println(diffInMillies);
	}
	
	private static void TestLoadWindowsKeyStore() {
		try {
			ArrayList<KeyStoreHolder> store = KeyStoreLoader.loadStoreFromWindows();
			System.out.println(store.size());
		} catch (Exception e) {
			e.printStackTrace();
		} 
	}
	
	private static void TestSignData() {
		AzTrustCryptoLib lib = new AzTrustCryptoLib();
		String inputdata = "123";
		String cer_issuer = "CN = test_ca, C = AZ";
		String cer_serial = "408fc12d";
		String hash_oid = "1.2.840.113549.1.1.11";
		String containerName = "PKCS11";
		String containerPassword = "Aa123456789";
		String containerFilePath = ""; 
		int detached = 1;
		String res = "";
		try
		{
			lib.signData(inputdata, cer_issuer, cer_serial, hash_oid, containerName, containerPassword, containerFilePath, detached);
		}
		catch(Exception ex){
			System.err.println(ex.getMessage());
		}
		System.out.println(res);
	}
}
