package com.crypto.utils.helpers;

import java.io.InputStream;
import javax.xml.crypto.Data;
import javax.xml.crypto.OctetStreamData;
import javax.xml.crypto.URIDereferencer;
import javax.xml.crypto.URIReference;
import javax.xml.crypto.URIReferenceException;
import javax.xml.crypto.XMLCryptoContext;
import javax.xml.crypto.dsig.XMLSignatureFactory;
import org.apache.commons.lang3.StringUtils;

public class NoUriDereferencer implements URIDereferencer {
  
  private InputStream inputStream;

  public NoUriDereferencer(InputStream inputStream) {
     this.inputStream = inputStream;
  }

  @Override
  public Data dereference(URIReference uriRef, XMLCryptoContext ctx) { 
		  //throws URIReferenceException {
     try{
     if (StringUtils.isBlank(uriRef.getURI()))
           return new OctetStreamData(inputStream);

     final URIDereferencer defaultDereferencer = XMLSignatureFactory.getInstance("DOM")
               .getURIDereferencer();
     return defaultDereferencer.dereference(uriRef, ctx);
     }catch (URIReferenceException e)
     {
    	 return null;
     }
  }
}